import processing.core.*; 
import processing.xml.*; 

import de.bezier.data.sql.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class pj2_main extends PApplet {

// 2013 Winter MAT 259 Data Visualization
// Lab. SQL in Processing - connect mySQL into Processing
// by Yoon Chung Han


// To import SQL Library, please download it here
// (http://bezier.de/processing/libs/sql/)
// and move the SQLibrary folder into your libraries folder. 
// (Please follow the detailed instruction from the website)



MySQL msql;
int[] coffeeByYear = new int[2012];
int[] teaByYear = new int[2012];
int numYears = 6;
String DL = ","; //the DELIMITER
PFont sideLabelFont;


public void setup() {
  // Prep canvas
  size(1024,768);
  
  // Load fonts
  sideLabelFont = createFont("HelveticaNeue", 13);
  
  msql = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
  if ( msql.connect() )
  { 
    String query = "select year(cout) as 'Year', sum(case when (title like '%coffee%' or subj like '%coffee%') then 1 else 0 end) as 'Coffee Count', sum(case when (title like '% tea %' or title like '% tea' or title like 'tea %' or subj like '% tea %' or subj like '% tea' or subj like 'tea %') then 1 else 0 end) as 'Tea Count' from inraw where(title like '%coffee%' or subj like '%coffee%' or title like '% tea %' or title like '% tea' or title like 'tea %' or subj like '% tea %' or subj like '% tea' or subj like 'tea %') and year(cout) >= 2006 group by year(cout)order by year(cout) asc;";
    msql.query(query);
    //msql.next();
    while (msql.next ()) {
      println( msql.getString(1) + DL + msql.getString(2) + DL + msql.getString(3));
      //transactionArray.add(new Transaction(msql.getString(1),msql.getString(2),msql.getString(3),msql.getFloat(4)));
      coffeeByYear[msql.getInt(1)] = msql.getInt(2);
      teaByYear[msql.getInt(1)] = msql.getInt(3);
    }
  }
  else
  {
    println(" connection failed !");
  }
  
  println(coffeeByYear);
  println(teaByYear);
  
  String[] fontList = PFont.list();
  //println(fontList);
}



int leftMargin = 40;
int rightMargin = 20;
int topMargin = 20;
int bottomMargin = 20;
int barSpacing = 10;
float barWidth = 100;

public void draw() {
  
  barWidth = PApplet.parseFloat(width-leftMargin-rightMargin-(numYears-1)*barSpacing)/numYears;
  
  background(37);
  
  textFont(sideLabelFont);
  //textAlign(CENTER, CENTER);
  
  noStroke();
  
  // Coffee label
  fill(145);
  pushMatrix();
  translate(leftMargin/2.0f, height/3.0f);
  rotate(-HALF_PI);
  text("Coffee", 0, 0);
  popMatrix();
  
  // Tea label
  pushMatrix();
  translate(leftMargin/2.0f, 2*height/3.0f);
  rotate(-HALF_PI);
  text("Tea", 0, 0);
  popMatrix();
  
  // Year labels
  for (int i=0; i < numYears; i++) {
    fill(i*20);
    int year = 2006+i;
    
    float pos = (width-leftMargin-rightMargin)*(i/PApplet.parseFloat(numYears))+leftMargin;


    float coffeeHeight = PApplet.parseFloat(coffeeByYear[year]) / (coffeeByYear[year]+teaByYear[year]) * (height-topMargin-bottomMargin);

    rect(pos, topMargin, pos+barWidth, coffeeHeight+topMargin);
    
    text(year, pos+barWidth/2.0f, height-20);
  }
  
  
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "pj2_main" });
  }
}
